再探java基础——throw与throws

原创 2013年08月31日 14:30:49

再探java基础——throwthrows

以前虽然知道一些异常的处理,也用过一些,但是对throwthrows区别还是有不太清楚。今天用实例测试一下。

异常处理机制

异常处理是对可能出现的异常进行处理,以防止程序遇到异常时被卡死,处于一直等待,或死循环。

异常有两个过程,一个是抛出异常;一个是捕捉异常。

抛出异常

抛出异常有三种形式,一是throw,一个throws,还有一种系统自动抛异常。下面它们之间的异同。

系统自动抛异常

当程序语句出现一些逻辑错误、主义错误或类型转换错误时,系统会自动抛出异常。如:

public static void main(String[] args) {
		int a = 5, b =0;
		System.out.println(5/b);
		//function();
}
系统会自动抛出ArithmeticException异常:

Exception in thread "main" java.lang.ArithmeticException: / by zero

at test.ExceptionTest.main(ExceptionTest.java:62)

  再如

public static void main(String[] args) {
		String s = "abc";
		System.out.println(Double.parseDouble(s));
		//function();
}
系统会自动抛出NumberFormatException异常:

Exception in thread "main" java.lang.NumberFormatException: For input string: "abc"

at sun.misc.FloatingDecimal.readJavaFormatString(FloatingDecimal.java:1224)

at java.lang.Double.parseDouble(Double.java:510)

at test.ExceptionTest.main(ExceptionTest.java:62)


throw

throw是语句抛出一个异常。
语法:throw (异常对象);
      如:  throw e;

一般会用于程序出现某种逻辑时程序员主动抛出某种特定类型的异常。如:

public static void main(String[] args) {
		String s = "abc";
		if(s.equals("abc")) {
			throw new NumberFormatException();
		} else {
			System.out.println(s);
		}
		//function();
}

会抛出异常:

Exception in thread "main" java.lang.NumberFormatException

at test.ExceptionTest.main(ExceptionTest.java:67)



throws

throws是方法可能抛出异常的声明。(用在声明方法时,表示该方法可能要抛出异常)
语法:[(修饰符)](返回值类型)(方法名)([参数列表])[throws(异常类)]{......}
      如:      public void function() throws Exception{......}

当某个方法可能会抛出某种异常时用于throws 声明可能抛出异常,然后交给上层调用它的方法程序处理。如:

public static void function() throws NumberFormatException{
		String s = "abc";
		System.out.println(Double.parseDouble(s));
	}
	
	public static void main(String[] args) {
		try {
			function();
		} catch (NumberFormatException e) {
			System.err.println("非数据类型不能转换。");
			//e.printStackTrace();
		}
}
处理结果如下:

非数据类型不能转换。

throwthrows的比较

1throws出现在方法函数头;而throw出现在函数体。

2throws表示出现异常的一种可能性,并不一定会发生这些异常;throw则是抛出了异常,执行throw则一定抛出了某种异常对象

3两者都是消极处理异常的方式(这里的消极并不是说这种方式不好),只是抛出或者可能抛出异常,但是不会由函数去处理异常,真正的处理异常由函数的上层调用处理。


好的编程习惯:

1.在写程序时,对可能会出现异常的部分通常要用try{...}catch{...}去捕捉它并对它进行处理;

2.try{...}catch{...}捕捉了异常之后一定要对在catch{...}中对其进行处理,那怕是最简单的一句输出语句,或栈输入e.printStackTrace();

3.如果是捕捉IO输入输出流中的异常,一定要在try{...}catch{...}后加finally{...}把输入输出流关闭;

4.如果在函数体内用throw抛出了某种异常,最好要在函数名中加throws抛异常声明,然后交给调用它的上层函数进行处理。


捕捉异常

先讲捕捉异常

try{
 ……
}catch(Exception e){
 ……
}finally{
 ……
}

try{……}中放置可能会发生异常的的语句块,如可能出现异常的函数,也可以是一般的程序语句;catch(){……}用于抓住异常,(Exception e)中Exception是异常的类型,必须是Exception(Exception是所有异常类的父类)的子类。{}定义当出现异常时的处理方法。finally{……}表示不管异常是否发生,都得进行finally{}中的处理。


在捕捉异常的try{...}语句块中,如果出现了异常,则该语句(出现异常的语句)后的程序语句都不执行,而是跳到catch{...}语句块中执行异常的处理。如:

public static void function1() throws NumberFormatException{
		System.out.println(Double.parseDouble("abc"));
		System.out.println("第二条语句。");
		
	}

	public static void main(String[] args) {
		try {
			function1();
		} catch (Exception e) {
			System.err.println(e.getMessage());
			//e.printStackTrace();
		}
}

结果如下,只输出了一条错误提示语:

For input string: "abc"

System.out.println("第二条语句。");未执行。


如果一个函数没有用throws进行抛异常,在调用该函数的方法也同样可以捕捉异常。如

public static void function() {
		String s = "abc";
		System.out.println(Double.parseDouble(s));
	}
	
	public static void main(String[] args) {
		try {
			function();
		} catch (Exception e) {
			System.err.println("非数据类型不能转换。");
			//e.printStackTrace();
		}
}
处理结果如下:

非数据类型不能转换。


说明:某个函数或某段程序块不管会不会,有没可能抛出异常,都可以加try{...}catch{...}去捕捉它。


自定义异常

用户可以自定义异常,新建一个异常类,让其继承Exception类或Exception的某个子类。然后用throw抛出自己定义的异常类对象。如:

public static void function() throws ParenthesisMatchingException{
		String s = "((a+b)";
		ParenthesisMatchingException e = new ParenthesisMatchingException("括号匹配异常!");
		if(s.charAt(0)=='(' && s.charAt(1)=='(') {
			throw e;
		}
		System.out.println(s);
	}
	
	public static void main(String[] args) {
		try {
			function();
		} catch (Exception e) {
			System.out.println(e.getMessage());
			//e.printStackTrace();
		}
}

结果如下 :

括号匹配异常!


版权声明:本文为博主原创文章,未经博主允许不得用于任何商业用途,转载请注明出处。

相关文章推荐

Java中throw和throws的区别

系统自动抛出的异常所有系统定义的编译和运行异常都可以由系统自动抛出,称为标准异常,并且 Java 强烈地要求应用程序进行完整的异常处理,给用户友好的提示,或者修正后使程序继续执行。 语句抛出的异常 用...

java中抛出throw关键字是怎么用的? 举例?

5.抛出throw关键字 马 克-to-win:我们先说5/0的原理,当程序运行到5/0的时候,java系统JVM会在后台new出一个除0异常实例,之后把这个实例传入 catch块儿供开发者使用...

java异常处理之throw, throws,try和catch

程序运行过程中可能会出现异常情况,比如被0除、对负数计算平方根等,还有可能会出现致命的错误,比如内存不足,磁盘损坏无法读取文件等,对于异常和错误情况的处理,统称为异常处理。    Java异常处理主要...

java异常处理之throw, throws,try和catch

程序运行过程中可能会出现异常情况,比如被0除、对负数计算平方根等,还有可能会出现致命的错误,比如内存不足,磁盘损坏无法读取文件等,对于异常和错误情况的处理,统称为异常处理。 Java异常处理主要...

RxJava2 浅析

作者: maplejaw 开源库地址:https://github.com/ReactiveX/RxJava 版本: compile 'io.reactivex.rxjava2:rxja...

throw和throws用法

1.java处理异常方式在java代码中如果发生异常的话,jvm会抛出异常对象,导致程序代码中断,这个时候jvm在做的操作就是:创建异常对象,然后抛出,比如: int i= 1; int j = 0...

【技术】Java入门:详解Java异常处理中throw与throws关键字的用法区别

转自http://www.jb51.net/article/74767.htm 抛出异常 抛出异常有三种形式,一是throw,一个throws,还有一种系统自动抛异常。下面它们之间的异同。 ...

java中的throw new Exception();和throw e;异常抛出

java代码如下: package com.imooc.exception; public class Throw1 {     public static void main(St...
  • wmc_bk
  • wmc_bk
  • 2017-02-27 17:22
  • 4643

第一个Android项目——计算器

第一个Android项目——计算器 效果 开始学Android一两个星期了,学习了一下基本的Activity、简单控件及几个简单布局,打算找个东西来练练手,于是就选择发计算器。关于计算器中用到的四...

java中的异常捕获及处理

package com.imooc.exception; import java.util.Scanner; public class ThrowExceptionTest {   ...
内容举报
返回顶部
收藏助手
不良信息举报
您举报文章:深度学习:神经网络中的前向传播和反向传播算法推导
举报原因:
原因补充:

(最多只允许输入30个字)